﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System;
using System.ComponentModel.DataAnnotations;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий связь преподавателя и должность кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("LecturerEmployeePost", "Связь преподавателя и должность кафедры")]
	[EntityDependency("EmployeePost", "EmployeePostId", "К какой должности относится преподаватель")]
	[EntityDependency("Lecturer", "LecturerId", "К какой должности относится преподаватель")]
	public class LecturerEmployeePost : BaseEntity, IEntitySecurityExtenstion<LecturerEmployeePost>
	{
		[DataMember]
		[Required]
		[MapConfiguration("LecturerId")]
		public Guid LecturerId { get; set; }

		[DataMember]
		[Required]
		[MapConfiguration("EmployeePostId")]
		public Guid EmployeePostId { get; set; }

		[DataMember]
		[Required]
		[MapConfiguration("Rate")]
		public decimal Rate { get; set; }

		[DataMember]
		[MapConfiguration("IsInternalCombination")]
		public bool IsInternalCombination { get; set; }

		[DataMember]
		[MapConfiguration("IsExternalCombination")]
		public bool IsExternalCombination { get; set; }

		//-------------------------------------------------------------------------

		public virtual EmployeePost EmployeePost { get; set; }

		public virtual Lecturer Lecturer { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		public LecturerEmployeePost SecurityCheck(LecturerEmployeePost entity, bool allowFullData) => entity;
	}
}