﻿using ModuleTools.Attributes;
using ModuleTools.Interfaces;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Runtime.Serialization;

namespace DatabaseCore.Models.Department
{
	/// <summary>
	/// Класс, описывающий должность преподавателя кафедры
	/// </summary>
	[DataContract]
	[EntityDescription("LecturerPost", "Должность преподавателя кафедры")]
	public class LecturerPost : BaseEntity, IEntitySecurityExtenstion<LecturerPost>
	{
		[DataMember]
		[Required]
		[MapConfiguration("LecturerPostName")]
		public string LecturerPostName { get; set; }

		[DataMember]
		[Required]
		[MapConfiguration("Hours")]
		public int Hours { get; set; }

		[DataMember]
		[MapConfiguration("Order")]
		public int Order { get; set; }

		//-------------------------------------------------------------------------

		//-------------------------------------------------------------------------

		[ForeignKey("LecturerPostId")]
		public virtual List<Lecturer> Lecturers { get; set; }

		//-------------------------------------------------------------------------

		public LecturerPost SecurityCheck(LecturerPost entity, bool allowFullData) => entity;
	}
}