﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.ViewModels;
using System;

namespace DepartmentBusinessLogic.ViewModels
{
	class DisciplineViewModels
	{
	}
	/// <summary>
	/// Список дисциплин
	/// </summary>
	public class DisciplineListViewModel : ListViewModel<DisciplineViewModel> { }

	/// <summary>
	/// Элемент дисциплина
	/// </summary>
	[ViewModelControlElementClass()]
	public class DisciplineViewModel : ElementViewModel
	{
		[ViewModelControlElementProperty("Блок дисциплин", ControlType.ControlGuid, MustHaveValue = true, ReadOnly = false, ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlDisciplineBlockList, DepartmentWindowsDesktop")]
		[MapConfiguration("DisciplineBlockId")]
		public Guid DisciplineBlockId { get; set; }

		[ViewModelControlListProperty("Блок дисциплин")]
		[MapConfiguration("DisciplineBlock.Title", IsDifficle = true)]
		public string DisciplineBlockTitle { get; set; }

		[ViewModelControlListProperty("Название дисциплины")]
		[ViewModelControlElementProperty("Название дисциплины", ControlType.ControlString, MustHaveValue = true)]
		[MapConfiguration("DisciplineName")]
		public string DisciplineName { get; set; }

		[ViewModelControlListProperty("Краткое название дисциплины")]
		[ViewModelControlElementProperty("Краткое нисциплины", ControlType.ControlString, MustHaveValue = true)]
		[MapConfiguration("DisciplineShortName")]
		public string DisciplineShortName { get; set; }

		[ViewModelControlElementProperty("Название в планах", ControlType.ControlString)]
		[MapConfiguration("DisciplineBlueAsteriskName")]
		public string DisciplineBlueAsteriskName { get; set; }

		public override string ToString() => DisciplineName;
	}
}