﻿using ModuleTools.Attributes;
using ModuleTools.Enums;
using ModuleTools.ViewModels;

namespace DepartmentBusinessLogic.ViewModels
{
	/// <summary>
	/// Список должностей преподавателей
	/// </summary>
	public class LecturerPostListViewModel : ListViewModel<LecturerPostViewModel> { }

	/// <summary>
	/// Элемент должности преподавателей
	/// </summary>
	[ViewModelControlElementClass(HaveDependenceEntities = true, Width = 800, Height = 500)]
	[ViewModelControlElementDependenceEntity(Title = "Преподаватели", Order = 1, ParentPropertyName = "LecturerPostId",
		ControlTypeObject = "DepartmentWindowsDesktop.EntityControls.ControlLecturerList, DepartmentWindowsDesktop")]
	public class LecturerPostViewModel : ElementViewModel
	{
		[ViewModelControlListProperty("Название должности")]
		[ViewModelControlElementProperty("Название должности", ControlType.ControlString, MustHaveValue = true)]
		[MapConfiguration("LecturerPostName")]
		public string LecturerPostName { get; set; }

		[ViewModelControlListProperty("Часы", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Часы", ControlType.ControlInt, MustHaveValue = true)]
		[MapConfiguration("Hours")]
		public int Hours { get; set; }

		[ViewModelControlListProperty("Порядок", ColumnWidth = 100)]
		[ViewModelControlElementProperty("Порядок", ControlType.ControlInt, MustHaveValue = true)]
		[MapConfiguration("Order")]
		public int Order { get; set; }

		public override string ToString() => LecturerPostName;
	}
}