﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка ученых званий
	/// </summary>
	public partial class ControlLecturerAcademicRankList :
		GenericControlEntityList<LecturerAcademicRankGetBindingModel, LecturerAcademicRankSetBindingModel, LecturerAcademicRankListViewModel, LecturerAcademicRankViewModel, LecturerAcademicRankBusinessLogic>,
		IGenericControlEntityList<LecturerAcademicRankListViewModel, LecturerAcademicRankViewModel>
	{
		public ControlLecturerAcademicRankList()
		{
			InitializeComponent();
			Title = "Ученые звания преподавателей";
			ControlId = new Guid("f38651c5-6717-49ca-bd3f-2556bb90a7a0");
			AccessOperation = AccessOperation.Преподаватели;
			ControlViewEntityElement = new ControlLecturerAcademicRankElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlLecturerAcademicRankList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public LecturerAcademicRankListViewModel GetDataForControl() => _businessLogic.GetList(new LecturerAcademicRankGetBindingModel());

		public LecturerAcademicRankListViewModel GetDataFromParentForControl(Guid id) => throw new NotImplementedException();

		public LecturerAcademicRankListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public LecturerAcademicRankListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}