﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	public partial class ControlLecturerLecturerAcademicRankList :
		GenericControlEntityList<LecturerGetBindingModel, LecturerSetBindingModel, LecturerListViewModel, LecturerViewModel, LecturerBusinessLogic>,
		IGenericControlEntityList<LecturerListViewModel, LecturerViewModel>
	{
		public ControlLecturerLecturerAcademicRankList()
		{
			InitializeComponent();
			Title = "Преподаватели";
			ControlId = new Guid("1bb5ddcc-7f5f-4c6e-a6ba-fe71852f9a47");
			AccessOperation = AccessOperation.Преподаватели;
			ControlViewEntityElement = new ControlEmployeeElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlLecturerLecturerAcademicRankList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public LecturerListViewModel GetDataForControl() => throw new NotImplementedException();

		public LecturerListViewModel GetDataFromParentForControl(Guid id) => _businessLogic.GetList(new LecturerGetBindingModel { LecturerAcademicRankId = id });

		public LecturerListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public LecturerListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}