﻿using DepartmentBusinessLogic.BindingModels;
using DepartmentBusinessLogic.BusinessLogics;
using DepartmentBusinessLogic.ViewModels;
using DesktopTools.Controls;
using DesktopTools.Enums;
using DesktopTools.Interfaces;
using DesktopTools.Models;
using ModuleTools.Enums;
using System;
using System.Collections.Generic;

namespace DepartmentWindowsDesktop.EntityControls
{
	/// <summary>
	/// Реализация контрола для списка должностей преподавателей
	/// </summary>
	public partial class ControlLecturerPostList :
		GenericControlEntityList<LecturerPostGetBindingModel, LecturerPostSetBindingModel, LecturerPostListViewModel, LecturerPostViewModel, LecturerPostBusinessLogic>,
		IGenericControlEntityList<LecturerPostListViewModel, LecturerPostViewModel>
	{
		public ControlLecturerPostList()
		{
			InitializeComponent();
			Title = "Должности преподавателей";
			ControlId = new Guid("ffbb6972-e720-42f7-a0ce-005ee36753e6");
			AccessOperation = AccessOperation.Преподаватели;
			ControlViewEntityElement = new ControlLecturerPostElement();
			_genericControlViewEntityList = this;
		}

		public IControl GetInstanceGenericControl() => new ControlLecturerPostList() { ControlId = Guid.NewGuid() };

		public ControlViewEntityListConfiguration GetConfigControl() => new()
		{
			PaginationOn = false,
			HideToolStripButton = new List<ToolStripButtonListNames>
			{
				ToolStripButtonListNames.toolStripButtonSearch
			}
		};

		public LecturerPostListViewModel GetDataForControl() => _businessLogic.GetList(new LecturerPostGetBindingModel());

		public LecturerPostListViewModel GetDataFromParentForControl(Guid id) => throw new NotImplementedException();

		public LecturerPostListViewModel GetDataWithPageNameForControl(string key) => throw new NotImplementedException();

		public LecturerPostListViewModel GetDataWithPageNumberForControl(int page, int count) => throw new NotImplementedException();
	}
}